/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * HttpFailure
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpFailure {

    /**
     * Get empty error form server
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getEmptyError(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<boolean>): void;
    getEmptyError(callback: ServiceCallback<boolean>): void;

    /**
     * Get empty error form server
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getNoModelError(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<boolean>): void;
    getNoModelError(callback: ServiceCallback<boolean>): void;
}

/**
 * @class
 * HttpSuccess
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpSuccess {

    /**
     * Return 200 status code if successful
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head200(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head200(callback: ServiceCallback<void>): void;

    /**
     * Get 200 success
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<boolean>): void;
    get200(callback: ServiceCallback<boolean>): void;

    /**
     * Put boolean value true returning 200 success
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put200(callback: ServiceCallback<void>): void;

    /**
     * Patch true Boolean value in request returning 200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch200(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch200(callback: ServiceCallback<void>): void;

    /**
     * Post bollean value true in request that returns a 200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post200(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post200(callback: ServiceCallback<void>): void;

    /**
     * Delete simple boolean value true returns 200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete200(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    delete200(callback: ServiceCallback<void>): void;

    /**
     * Put true Boolean value in request returns 201
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put201(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put201(callback: ServiceCallback<void>): void;

    /**
     * Post true Boolean value in request returns 201 (Created)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post201(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post201(callback: ServiceCallback<void>): void;

    /**
     * Put true Boolean value in request returns 202 (Accepted)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put202(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put202(callback: ServiceCallback<void>): void;

    /**
     * Patch true Boolean value in request returns 202
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch202(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch202(callback: ServiceCallback<void>): void;

    /**
     * Post true Boolean value in request returns 202 (Accepted)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post202(callback: ServiceCallback<void>): void;

    /**
     * Delete true Boolean value in request returns 202 (accepted)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    delete202(callback: ServiceCallback<void>): void;

    /**
     * Return 204 status code if successful
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head204(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head204(callback: ServiceCallback<void>): void;

    /**
     * Put true Boolean value in request returns 204 (no content)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put204(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put204(callback: ServiceCallback<void>): void;

    /**
     * Patch true Boolean value in request returns 204 (no content)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch204(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch204(callback: ServiceCallback<void>): void;

    /**
     * Post true Boolean value in request returns 204 (no content)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post204(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post204(callback: ServiceCallback<void>): void;

    /**
     * Delete true Boolean value in request returns 204 (no content)
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete204(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    delete204(callback: ServiceCallback<void>): void;

    /**
     * Return 404 status code
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head404(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head404(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * HttpRedirects
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpRedirects {

    /**
     * Return 300 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head300(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head300(callback: ServiceCallback<void>): void;

    /**
     * Return 300 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get300(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<string[]>): void;
    get300(callback: ServiceCallback<string[]>): void;

    /**
     * Return 301 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head301(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head301(callback: ServiceCallback<void>): void;

    /**
     * Return 301 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get301(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get301(callback: ServiceCallback<void>): void;

    /**
     * Put true Boolean value in request returns 301.  This request should not be
     * automatically redirected, but should return the received 301 to the caller
     * for evaluation
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put301(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put301(callback: ServiceCallback<void>): void;

    /**
     * Return 302 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head302(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head302(callback: ServiceCallback<void>): void;

    /**
     * Return 302 status code and redirect to /http/success/200
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get302(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get302(callback: ServiceCallback<void>): void;

    /**
     * Patch true Boolean value in request returns 302.  This request should not
     * be automatically redirected, but should return the received 302 to the
     * caller for evaluation
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch302(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch302(callback: ServiceCallback<void>): void;

    /**
     * Post true Boolean value in request returns 303.  This request should be
     * automatically redirected usign a get, ultimately returning a 200 status
     * code
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post303(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post303(callback: ServiceCallback<void>): void;

    /**
     * Redirect with 307, resulting in a 200 success
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head307(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head307(callback: ServiceCallback<void>): void;

    /**
     * Redirect get with 307, resulting in a 200 success
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get307(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get307(callback: ServiceCallback<void>): void;

    /**
     * Put redirected with 307, resulting in a 200 after redirect
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put307(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put307(callback: ServiceCallback<void>): void;

    /**
     * Patch redirected with 307, resulting in a 200 after redirect
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch307(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch307(callback: ServiceCallback<void>): void;

    /**
     * Post redirected with 307, resulting in a 200 after redirect
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post307(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post307(callback: ServiceCallback<void>): void;

    /**
     * Delete redirected with 307, resulting in a 200 after redirect
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete307(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    delete307(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * HttpClientFailure
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpClientFailure {

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head400(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    head400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get400(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put400(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    put400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch400(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    patch400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post400(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    post400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 400 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete400(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    delete400(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 401 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head401(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    head401(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 402 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get402(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get402(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 403 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get403(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get403(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 404 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put404(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    put404(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 405 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch405(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    patch405(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 406 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post406(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    post406(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 407 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete407(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    delete407(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 409 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put409(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    put409(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 410 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head410(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    head410(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 411 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get411(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get411(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 412 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get412(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get412(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 413 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put413(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    put413(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 414 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch414(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    patch414(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 415 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post415(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    post415(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 416 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get416(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get416(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 417 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete417(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    delete417(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 429 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head429(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    head429(callback: ServiceCallback<models.ErrorModel>): void;
}

/**
 * @class
 * HttpServerFailure
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpServerFailure {

    /**
     * Return 501 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head501(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    head501(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 501 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get501(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    get501(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 505 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post505(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    post505(callback: ServiceCallback<models.ErrorModel>): void;

    /**
     * Return 505 status code - should be represented in the client as an error
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete505(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.ErrorModel>): void;
    delete505(callback: ServiceCallback<models.ErrorModel>): void;
}

/**
 * @class
 * HttpRetry
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface HttpRetry {

    /**
     * Return 408 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    head408(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    head408(callback: ServiceCallback<void>): void;

    /**
     * Return 500 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put500(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put500(callback: ServiceCallback<void>): void;

    /**
     * Return 500 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch500(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch500(callback: ServiceCallback<void>): void;

    /**
     * Return 502 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get502(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get502(callback: ServiceCallback<void>): void;

    /**
     * Return 503 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post503(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    post503(callback: ServiceCallback<void>): void;

    /**
     * Return 503 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete503(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    delete503(callback: ServiceCallback<void>): void;

    /**
     * Return 504 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put504(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    put504(callback: ServiceCallback<void>): void;

    /**
     * Return 504 status code, then 200 after retry
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {boolean} [options.booleanValue] Simple boolean value true
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    patch504(options: { booleanValue? : boolean, customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    patch504(callback: ServiceCallback<void>): void;
}

/**
 * @class
 * MultipleResponses
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestHttpInfrastructureTestService.
 */
export interface MultipleResponses {

    /**
     * Send a 200 response with valid payload: {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model204NoModelDefaultError200Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model204NoModelDefaultError200Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 204 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model204NoModelDefaultError204Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model204NoModelDefaultError204Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 201 response with valid payload: {'statusCode': '201'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model204NoModelDefaultError201Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model204NoModelDefaultError201Invalid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 202 response with no payload:
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model204NoModelDefaultError202None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model204NoModelDefaultError202None(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 400 response with valid error payload: {'status': 400, 'message':
     * 'client error'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model204NoModelDefaultError400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model204NoModelDefaultError400Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with valid payload: {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model201ModelDefaultError200Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model201ModelDefaultError200Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 201 response with valid payload: {'statusCode': '201',
     * 'textStatusCode': 'Created'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model201ModelDefaultError201Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model201ModelDefaultError201Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 400 response with valid payload: {'code': '400', 'message': 'client
     * error'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200Model201ModelDefaultError400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200Model201ModelDefaultError400Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with valid payload: {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA201ModelC404ModelDDefaultError200Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;
    get200ModelA201ModelC404ModelDDefaultError200Valid(callback: ServiceCallback<any>): void;

    /**
     * Send a 200 response with valid payload: {'httpCode': '201'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA201ModelC404ModelDDefaultError201Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;
    get200ModelA201ModelC404ModelDDefaultError201Valid(callback: ServiceCallback<any>): void;

    /**
     * Send a 200 response with valid payload: {'httpStatusCode': '404'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA201ModelC404ModelDDefaultError404Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;
    get200ModelA201ModelC404ModelDDefaultError404Valid(callback: ServiceCallback<any>): void;

    /**
     * Send a 400 response with valid payload: {'code': '400', 'message': 'client
     * error'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA201ModelC404ModelDDefaultError400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<any>): void;
    get200ModelA201ModelC404ModelDDefaultError400Valid(callback: ServiceCallback<any>): void;

    /**
     * Send a 202 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultError202None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultError202None(callback: ServiceCallback<void>): void;

    /**
     * Send a 204 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultError204None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultError204None(callback: ServiceCallback<void>): void;

    /**
     * Send a 400 response with valid payload: {'code': '400', 'message': 'client
     * error'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultError400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultError400Valid(callback: ServiceCallback<void>): void;

    /**
     * Send a 202 response with an unexpected payload {'property': 'value'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultNone202Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultNone202Invalid(callback: ServiceCallback<void>): void;

    /**
     * Send a 204 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultNone204None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultNone204None(callback: ServiceCallback<void>): void;

    /**
     * Send a 400 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultNone400None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultNone400None(callback: ServiceCallback<void>): void;

    /**
     * Send a 400 response with an unexpected payload {'property': 'value'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get202None204NoneDefaultNone400Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    get202None204NoneDefaultNone400Invalid(callback: ServiceCallback<void>): void;

    /**
     * Send a 200 response with valid payload: {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultModelA200Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    getDefaultModelA200Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultModelA200None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    getDefaultModelA200None(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 400 response with valid payload: {'statusCode': '400'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultModelA400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    getDefaultModelA400Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 400 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultModelA400None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    getDefaultModelA400None(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with invalid payload: {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultNone200Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getDefaultNone200Invalid(callback: ServiceCallback<void>): void;

    /**
     * Send a 200 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultNone200None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getDefaultNone200None(callback: ServiceCallback<void>): void;

    /**
     * Send a 400 response with valid payload: {'statusCode': '400'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultNone400Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getDefaultNone400Invalid(callback: ServiceCallback<void>): void;

    /**
     * Send a 400 response with no payload
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    getDefaultNone400None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<void>): void;
    getDefaultNone400None(callback: ServiceCallback<void>): void;

    /**
     * Send a 200 response with no payload, when a payload is expected - client
     * should return a null object of thde type for model A
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA200None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA200None(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with payload {'statusCode': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA200Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA200Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with invalid payload {'statusCodeInvalid': '200'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA200Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA200Invalid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 400 response with no payload client should treat as an http error
     * with no error model
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA400None(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA400None(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with payload {'statusCode': '400'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA400Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA400Valid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 200 response with invalid payload {'statusCodeInvalid': '400'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA400Invalid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA400Invalid(callback: ServiceCallback<models.A>): void;

    /**
     * Send a 202 response with payload {'statusCode': '202'}
     *
     * @param {object} [options] Optional Parameters.
     * 
     * @param {object} [options.customHeaders] Headers that will be added to the
     * request
     * 
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    get200ModelA202Valid(options: { customHeaders? : { [headerName: string]: string; } }, callback: ServiceCallback<models.A>): void;
    get200ModelA202Valid(callback: ServiceCallback<models.A>): void;
}
