# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class FlattenParameterGroup(Model):
    """
    Additional parameters for one or more operations

    :param name: Product name with value 'groupproduct'
    :type name: str
    :param product_id: Unique identifier representing a specific product for
     a given latitude & longitude. For example, uberX in San Francisco will
     have a different product_id than uberX in Los Angeles.
    :type product_id: str
    :param description: Description of product.
    :type description: str
    :param max_product_display_name: Display name of product.
    :type max_product_display_name: str
    :param generic_value: Generic URL value.
    :type generic_value: str
    :param odatavalue: URL value.
    :type odatavalue: str
    """ 

    _validation = {
        'name': {'required': True},
        'product_id': {'required': True},
        'max_product_display_name': {'required': True},
    }

    def __init__(self, name, product_id, max_product_display_name, description=None, generic_value=None, odatavalue=None):
        self.name = name
        self.product_id = product_id
        self.description = description
        self.max_product_display_name = max_product_display_name
        self.generic_value = generic_value
        self.odatavalue = odatavalue
